import os
import sys
import string
#import EMAN
import commands
import math
import re
import shutil
from math import *
from sys import argv
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window


class foldhunter(ModelessDialog):
	name = "fhc ui"
	buttons = ("Apply","Close")
	title = "foldhunter"
	direman=os.environ["HOME"]
	hellp = "%s/EMAN/doc/fh_help.html"%(direman)
	help = hellp
	
	def targetSelector(self):
		##generate list of open volume files
		self.targets=[]
		self.targets=map(lambda x:x.name,filter(lambda x:str(x.__class__)=="VolumeViewer.surface.Surface_Model",chimera.openModels.list()))
		self.targetButton.setitems(self.targets)

	def probeSelector(self):
		##generate list of open volume files
		self.probes=[]
		self.probes=map(lambda x:x.name,chimera.openModels.list())
		self.probeButton.setitems(self.probes)

	def refineSelector(self):
		##generate list of open volume files
		self.refines=[]
		self.refines=map(lambda x:x.name,chimera.openModels.list())
		self.refineButton.setitems(self.refines)	

	def openResults(self):
		if (self.result.get()=='None'):
			return
		else:
			print self.result.get()
			currentModel=str(self.result.get())
			print currentModel
			chimera.openModels.open(currentModel)
			
	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame1A=Tkinter.Frame(self.frame0, relief=FLAT)
		self.frame1A.grid(column=0,row=0, sticky=EW)
		self.frame1B=Tkinter.Frame(self.frame0, relief=FLAT)
		self.frame1B.grid(column=0,row=1, sticky=EW)		
		self.frame2=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame2.grid(column=1,row=0, sticky=EW)
		self.frame3=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame3.grid(column=1,row=1, sticky=EW)
		self.frame4=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame4.grid(column=0,row=1, sticky=EW)
		self.frame5=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame5.grid(column=0,row=2, sticky=EW)
		
		##Target Selection
		Label(self.frame1A, text='target file:').grid(row=0, column=0, sticky=W)
		self.target=StringVar()
		self.targetButton=Pmw.OptionMenu(self.frame1A,labelpos=W, menubutton_textvariable=self.target)
		self.targetButton.grid(row=0, column=1, sticky=W)
		self.targetSelector()
		self.filechoiceTarget=IntVar()
		t = Checkbutton(self.frame1A, text="Use external file", variable=self.filechoiceTarget).grid(row=1, sticky=W)
		self.target2 = Entry(self.frame1A, width = 16)		
		self.target2.grid(row=1, column=1, sticky=W)
		
		##Probe Selection
		Label(self.frame1B, text='probe file:').grid(row=0, column=0, sticky=W)
		self.probe=StringVar()
		self.probeButton=Pmw.OptionMenu(self.frame1B,labelpos=W, menubutton_textvariable=self.probe)
		self.probeButton.grid(row=0, column=1, sticky=W)
		self.probeSelector()
		self.filechoiceProbe=IntVar()
		p = Checkbutton(self.frame1B, text="Use external file", variable=self.filechoiceProbe).grid(row=1, sticky=W)
		self.probe2 = Entry(self.frame1B, width = 16)		
		self.probe2.grid(row=1, column=1, sticky=W)
		
		##Required parameters
		Label(self.frame2, text='Required').grid(row=0, sticky=W)
		Label(self.frame2, text='apix:').grid(row=1, column=0, sticky=W)
		Label(self.frame2, text='res:').grid(row=2, column=0, sticky=W)
		Label(self.frame2, text=' ').grid(row=3, column=0, sticky=W)
		Label(self.frame2, text=' ').grid(row=4, column=0, sticky=W)
		self.apix = Entry(self.frame2, width = 6)
		self.apix.grid(row=1, column=1, sticky=W)
		self.res = Entry(self.frame2, width = 6)
		self.res.grid(row=2, column=1, sticky=W)
		
		##Options and Filters
		Label(self.frame3, text='Options ').grid(row=0, sticky=W)
		Label(self.frame3, text='shrink: ').grid(row=1, column=0, sticky=W)
		Label(self.frame3, text='filters:').grid(row=3, column=0, sticky=W)
		Label(self.frame3, text='keep:').grid(row=2, column=0, sticky=W)
		
		shrink=StringVar()
		self.shrink = Entry(self.frame3, width = 4, textvariable=shrink)
		shrink.set("2")
		self.shrink.grid(row=1, column=1, sticky=W)
		self.filter=StringVar()
		keep=StringVar()
		self.keep = Entry(self.frame3, width = 4, textvariable=keep)
		keep.set("20")
		self.keep.grid(row=2, column=1, sticky=W)
		self.filter.set('None')
		options=['None', 'Binary', 'Threshold', 'Normalize', 'Laplacian']
		self.filterButton=Pmw.OptionMenu(self.frame3,labelpos=W, menubutton_textvariable=self.filter, items=options)
		self.filterButton.grid(row=3, column=1, sticky=W)
		self.filterValue=Entry(self.frame3, width=4)
		self.filterValue.grid(row=3, column=2, sticky=W)
		self.smart=IntVar()
		s = Checkbutton(self.frame3, text="SMART", variable=self.smart).grid(row=4, column=0, sticky=W)

		##Heirarchical Search
		self.hs=IntVar()
		h = Checkbutton(self.frame4, text="Heirarchical Search", variable=self.hs).grid(row=0, sticky=W)
		Label(self.frame4, text='depth:').grid(row=1, column=2, sticky=W)
		Label(self.frame4, text='Peak Distance:').grid(row=1, column=0, sticky=W)
		Label(self.frame4, text=' ').grid(row=3, column=0, sticky=W)
		Label(self.frame4, text=' ').grid(row=4, column=0, sticky=W)
		depth=StringVar()
		self.depth = Entry(self.frame4, width = 4, textvariable=depth)
		depth.set("1")
		self.depth.grid(row=1, column=3, sticky=W)
		pixel=StringVar()
		self.pixel = Entry(self.frame4, width = 4, textvariable=pixel)
		pixel.set("1")
		self.pixel.grid(row=1, column=1, sticky=W)
		self.result=StringVar()
		self.resultButton=Pmw.OptionMenu(self.frame4,label_text='results',labelpos=W, menubutton_textvariable=self.result)
		self.result.set('None')
		self.resultButton.grid(row=2, column=0, sticky=W)
		Button(self.frame4,text='Open', command=self.openResults).grid(row=2, column=1, sticky=W)

		##Refinement Search
		self.rs=IntVar()
		r = Checkbutton(self.frame5, text="Refinement", variable=self.rs).grid(row=0, sticky=W)
		self.refine=StringVar()
		self.refineButton=Pmw.OptionMenu(self.frame5,label_text='refine model: ',labelpos=W, menubutton_textvariable=self.refine)
		self.refine.set('None')
		self.refineButton.grid(row=1, column=0, sticky=W)
		self.refineSelector()
		Label(self.frame5, text='Angle:   ').grid(row=2, column=0, sticky=W)
		Label(self.frame5, text='Distance:').grid(row=2, column=2, sticky=W)
		angle=StringVar()
		self.angle = Entry(self.frame5, width = 4, textvariable=angle)
		angle.set("1")
		self.angle.grid(row=2, column=1, sticky=W)
		refdist=StringVar()
		self.refdist = Entry(self.frame5, width = 4, textvariable=refdist)
		refdist.set("1")
		self.refdist.grid(row=2, column=3, sticky=W)

	def Apply(self):
		crap=0
		if (self.filechoiceTarget.get()==0):
			target=self.target.get()
		else:
			target=self.target2.get()
		shutil.copy(target, 'target.mrc')
		t=target.split('.')
		targetExt=str(t[-1])
#		tempTarget=EMAN.EMData()
#		tempTarget.readImage('target.mrc')
#		mapSize=tempTarget.xSize()
		mapSize=10
		refineFLAG=0
		
		if (self.rs.get()==1):	
			probe=self.refine.get()
			refineFLAG=1
		else:
			if (self.filechoiceProbe.get()==0):
				probe=self.probe.get()
			else:
				probe=self.probe2.get()

		p=probe.split('.')
		probeName=str(p[0])
		probeExt=str(p[-1])	
		print probeExt
		
		apix=float(self.apix.get())
		res= float(self.res.get())
		shrink = int(self.shrink.get())
		keep=int(self.keep.get())

		if ((self.filter.get()=='None') or (self.filter.get()=='Normalize')): 
			value=None	
		else:
			value=float(self.filterValue.get())
		
		hs=0
		hs=int(self.hs.get())
					
		if hs==1:
			depth= int(self.depth.get())
			pixel=int(self.pixel.get())
		else:
			depth=1
			pixel=1

		########create user selection
		if (refineFLAG==1):
			selectedLength=0
			selected=chimera.selection.currentAtoms()
			selectedLength=len(selected)
			
			if (selectedLength!=0) and (probeExt=='pdb' or probeExt=='ent'):
				print "ENTERED USER SELECTION"	
				i=0
				selectedAtoms=[]
				while (i < selectedLength):
					selectedAtoms.append(chimera.selection.currentAtoms()[i].serialNumber)
					i=i+1
	
				selectedAtoms.sort()
				print selectedAtoms
				fileRefine=open(probe, "r")
				linesRefine=fileRefine.readlines()
				fileRefine.close()
				refinePDB=open("refine.pdb", "w")
				
				for lineRefine in linesRefine:
					isatom=str(lineRefine[0:6].strip())
					serialNum=str(lineRefine[6:11].strip())
					if (isatom=="ATOM"):
						serialNum=int(lineRefine[6:11].strip())
						if (serialNum in selectedAtoms):
							refinePDB.write(lineRefine)
				refinePDB.close()
				cmdRS0="pdb2mrc refine.pdb refine.mrc apix=%f res=%f box=%d"%(apix, res, mapSize)
				os.system(cmdRS0)
				cmdRS1="proc3d refine.mrc refine.mrc norm"
				os.system(cmdRS1)
			else:
				shutil.copy(probe, 'refine.mrc')	
			selected=chimera.selection.currentEmpty()
			selectedLength=0
				
		########Transform PDB file and generate MRC file
		if (probeExt=='pdb' or probeExt=='ent') and (refineFLAG==0):
			shutil.copy(probe, 'probe.pdb')
			cmd1="procpdb.py probe.pdb probe.pdb centeratoms"
			os.system(cmd1)
		
			cmd2="pdb2mrc probe.pdb probe.mrc apix=%f res=%f box=%d"%(apix, res, mapSize)
			os.system(cmd2)
			cmd3="proc3d probe.mrc probe.mrc norm"
			os.system(cmd3)
		else:
			shutil.copy(probe, 'probe.mrc')
#			tempProbe=EMAN.EMData()
#			tempProbe.readImage('probe.mrc')
#			tempsizeX=int(tempProbe.xSize())
#			tempsizeY=int(tempProbe.ySize())
#			tempsizeZ=int(tempProbe.zSize())
			tempsizeX=10
			tempsizeY=10
			tempsizeZ=10
			if (tempsizeX!=tempsizeY!=tempsizeZ!=mapSize):
				cmd3a="proc3d probe.mrc probe.mrc clip=%d,%d,%d"%(mapSize,mapSize,mapSize)
				os.system(cmd3a)
				
		########Filter and Scale MRC files
		if (self.filter.get()=='Threshold'):
			print("Tresholding target map")
			cmdF1="proc3d target.mrc target.mrc rfilt=0,%f"%(value)
			os.system(cmdF1)
		if (self.filter.get()=='Binary'):
			print("Binerizing target map")
			cmdF2="proc3d target.mrc target.mrc rfilt=2,%f"%(value)
			os.system(cmdF2)
		if (self.filter.get()=='Normalize'):
			print("Normalizing target map")
			cmdF3="proc3d target.mrc target.mrc  norm"
			os.system(cmdF3)
		if (self.filter.get()=='Laplacian'):
			print("Laplacian filter")
			cmdF4="proc3d target.mrc target.mrc rfilt=80,%f"%(value)
			os.system(cmdF4)
		if (refineFLAG==0):	
			print("Shrinking maps")
			cmdST="proc3d target.mrc target-shrink.mrc shrink=%f"%(shrink)
			os.system(cmdST)
			cmdSP="proc3d probe.mrc probe-shrink.mrc shrink=%f"%(shrink)
			os.system(cmdSP)
		pattern=re.compile(r"Solution\s(?P<solnum>\d+)\:\trotation\s=\s\(\s(?P<rotx>-?\d+(\.\d+)?(e.\d+)?)\s,\s(?P<rotz1>-?\d+(\.\d+)?(e.\d+)?)\s,\s(?P<rotz2>-?\d+(\.\d+)?(e.\d+)?)\s\)\ttranslation\s=\s\(\s(?P<dx>-?\d+(\.\d+)?(e.\d+)?)\s,\s(?P<dy>-?\d+(\.\d+)?(e.\d+)?)\s,\s(?P<dz>-?\d+(\.\d+)?(e.\d+)?)\s\)")

		#pattern=re.compile(r"Solution\s(?P<solnum>\d+)\:\trotation\s=\s\(\s(?P<rotx>-?\d+\.?\d*(e.\d+)?)\s,\s(?P<rotz1>-?\d+\.?\d*(e.\d+)?)\s,\s(?P<rotz2>-?\d+\.?\d*(e.\d+)?)\s\)\ttranslation\s=\s\(\s(?P<dx>-?\d+\.?\d*(e.\d+)?)\s,\s(?P<dy>-?\d+\.?\d*(e.\d+?))\s,\s(?P<dz>-?\d+\.?\d*(e.\d+)?)\s\)")
		self.listResults=[]
		
		###############################
		####### Run foldhunterP #######
		###############################
		
		########SMART option
		if (self.smart.get()==1):
			print "RUNNING SMART"
			logSmart="log-fh-%s.txt"%(probeName)
			outSmart="fh-smart-%s.mrc"%(probeName)
			cmdS1="foldhunterP target.mrc probe.mrc %s log=%s da=1 keep=%d "%(outSmart, logSmart, keep)
			os.system(cmdS1)
			if (probeExt=='pdb' or probeExt=='ent'):
				file0=open(logSmart, "r")
				lines0=file0.readlines()
				file0.close()
				fh0 = {}
				for line in lines0:
					ps=pattern.search(line)
					if ps:
						fh0[int(ps.group('solnum'))]=[float(ps.group('rotx')),float(ps.group('rotz1')),float(ps.group('rotz2')),float(ps.group('dx')),float(ps.group('dy')),float(ps.group('dz'))]

				fhSmart="fh-smart-%s"%(probe)
				cmdS2="procpdb.py probe.pdb r.pdb rot=%f,%f,%f"%(fh0[0][0],fh0[0][1],fh0[0][2])
				os.system(cmdS2)
				cmdS3="procpdb.py r.pdb %s apix=%f trans=%f,%f,%f"%(fhSmart,apix,fh0[0][3],fh0[0][4],fh0[0][5])
				os.system(cmdS3)
				chimera.openModels.open(fhSmart)
			else:
				chimera.openModels.open(outSmart)

				
		########Scale foldhunter	
		if (self.rs.get()!=1) and (self.smart.get()!=1):
			print "RUNNING FOLDHUNTERP WITH SHRINK"
			outShrink="fh-shrink-%s.mrc"%(probeName)
			da=((180*res)/(math.pi*(mapSize/(2*shrink))))/1.5
			cmdFHS="foldhunterP target-shrink.mrc probe-shrink.mrc %s log=log-fh-shrink.txt da=%f keep=%d"%(outShrink,da,keep)
			os.system(cmdFHS)

			########Parse output and repeat foldhunterP
			file1=open('log-fh-shrink.txt', "r")
			lines1=file1.readlines()
			file1.close()
			fh1 = {}
			for line in lines1:
				ps=pattern.search(line)
				if ps:
					fh1[int(ps.group('solnum'))]=[float(ps.group('rotx')),float(ps.group('rotz1')),float(ps.group('rotz2')),float(ps.group('dx')),float(ps.group('dy')),float(ps.group('dz'))]
			print("RUNNING FOLDHUNTERP")
			count=0
			children=0
			while ((count < depth) and (children < keep)):
				angle_range=((180*res)/(math.pi*mapSize))
#				angle_range=2
				if (angle_range > 20):
					angle_range=20
				da=1
				sphere_radius=0.0625*mapSize

				x1=shrink*fh1[children][3]
				y1=shrink*fh1[children][4]
				z1=shrink*fh1[children][5]

				dist = []
				solution=0
				while (solution <= children):
					x2=shrink*fh1[solution][3]
					y2=shrink*fh1[solution][4]
					z2=shrink*fh1[solution][5]
					if (solution!=children):
						distance=math.sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)
					else:
						distance=10000
					dist.append(distance)
					print "%d verse %d: %f"%(children,solution,dist[solution])
					solution=solution+1
				pixel_distance=min(dist)
	
				if ((pixel_distance >= pixel) or (count==0)):
					logfile="log-%s-%d.txt"%(probeName,count)
					cmdFH="foldhunterP target.mrc probe.mrc fh-%d.mrc log=%s da=%f startangle=%f,%f,%f range=%f sphere_region=%f,%f,%f,%f"%(children,logfile,da,fh1[children][0],fh1[children][1],fh1[children][2],angle_range,x1,y1,z1,sphere_radius)
					os.system(cmdFH)
					num=count
					count=count+1
		
					########Transform PDB
					if (probeExt=='pdb' or probeExt=='ent'):
						print("Transforming PDB")
						file2=open(logfile, "r")
						lines2=file2.readlines()
						file2.close()
						fh2 = {}
						for line in lines2:
							ps=pattern.search(line)
							if ps:
								fh2[int(ps.group('solnum'))]=[float(ps.group('rotx')),float(ps.group('rotz1')),float(ps.group('rotz2')),float(ps.group('dx')),float(ps.group('dy')),float(ps.group('dz'))]

						cmdROT="procpdb.py probe.pdb r.pdb rot=%f,%f,%f"%(fh2[0][0],fh2[0][1],fh2[0][2])
						os.system(cmdROT)
						cmdTRANS="procpdb.py r.pdb fh-solution-%d-%s apix=%f trans=%f,%f,%f"%(num,probe,apix,fh2[0][3],fh2[0][4],fh2[0][5])
						os.system(cmdTRANS)
						addFile="fh-solution-%d-%s"%(num,probe)
					else:
						addFile="fh-%d.mrc"%(children)
				children=children+1
				self.listResults.append(addFile)
			bestResult=self.listResults[0]
			chimera.openModels.open(bestResult)
			self.resultSelector()
		
		########Refinement option
		if (refineFLAG==1):
			print "RUNNING REFINEMENT"
			outRefine="fh-refine-%s.mrc"%(probeName)
			angl=float(self.angle.get())
			refdis=float(self.refdist.get())
			cmdREF1="foldhunterP target.mrc refine.mrc %s log=log-fh-refine.txt keep=%d da=1 startangle=0,0,0 range=%f sphere_region=0,0,0,%f"%(outRefine, keep, angl, refdis)
			os.system(cmdREF1)
			if (probeExt=='pdb' or probeExt=='ent'):
				fileR=open("log-fh-refine.txt", "r")
				linesR=fileR.readlines()
				fileR.close()
				fhR = {}
				for lineR in linesR:
					ps=pattern.search(lineR)
					if ps:
						fhR[int(ps.group('solnum'))]=[float(ps.group('rotx')),float(ps.group('rotz1')),float(ps.group('rotz2')),float(ps.group('dx')),float(ps.group('dy')),float(ps.group('dz'))]
 				outRefinePDB="fh-refine-%s.pdb"%(probeName)
				cmdR2="procpdb.py refine.pdb r.pdb rot=%f,%f,%f"%(fhR[0][0],fhR[0][1],fhR[0][2])
				os.system(cmdR2)
				cmdR3="procpdb.py r.pdb %s apix=%f trans=%f,%f,%f"%(outRefinePDB,apix,fhR[0][3],fhR[0][4],fhR[0][5])
				os.system(cmdR3)
				chimera.openModels.open(outRefinePDB)
			else:
				chimera.openModels.open(outRefine)		
#		cmdCLEANUP="rm target.mrc probe.mrc target-shrink.mrc probe-shrink.mrc r.pdb refine.mrc refine.pdb" 
#		os.system(cmdCLEANUP)
				
	def resultSelector(self):
		##generate list of open files
		if (hs==1):
			self.resultButton.setitems(self.listResults)	
		else:
			return
				
try:
	chimera.dialogs.register(foldhunter.name, foldhunter)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = foldhunter()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) : 
		dialog.targetSelector()
		dialog.probeSelector()
		dialog.resultSelector()
		dialog.refineSelector()
triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)

